      IMPLICIT REAL*8 (A-H,O-Z)
	PARAMETER (NP=2000,NP0=13)
	DIMENSION DLAM(3),PSI(NP),R(NP)
	OPEN(1,FILE='AMAT.DAT')
	QQ=2.0D-1
      WRITE(*,*) 'MOMENTUM=',QQ
      WRITE(1,*) 'MOMENTUM=',QQ
	RMIN=-5.D0
	WRITE(*,*) 'RMIN=',RMIN
	WRITE(1,*) 'RMIN=',RMIN
      RMAX=45.D0
	WRITE(*,*) 'RMAX=',RMAX
	WRITE(1,*) 'RMAX=',RMAX
    	IPOINT=6
	WRITE(*,*) 'NUMBER OF POINTS IN SUBINTERVAL=',IPOINT
	WRITE(1,*) 'NUMBER OF POINTS IN SUBINTERVAL=',IPOINT
      EPS=1.D-10
	WRITE(*,*) 'ACCURACY OF CALCULATION=',EPS
	WRITE(1,*) 'ACCURACY OF CALCULATION=',EPS
	NN=50
	WRITE(*,*) 'NUMBER OF SUBINTERVALS=',NN

      DO I=1,3
	CALL      SCATTERH6(DLAM1,PSI,QQ,RMIN,RMAX,R,NN,IPOINT,EPS)
	WRITE(*,*) 'NN=',NN,'DLAM=',DLAM1
      DLAM(I)=DLAM1
	NN=NN*2
	ENDDO
	SIGMA=(DLAM(1)-DLAM(2))/(DLAM(2)-DLAM(3))
      EXTRA=(DLAM(3)-DLAM(2)/SIGMA)/(1.D0-1.D0/SIGMA)
	WRITE(*,*) 'RUNGE COEFFICIENT=',SIGMA
	WRITE(1,*) 'RUNGE COEFFICIENT=',SIGMA
	WRITE(*,*) 'EXTRAPOLATION OF PHASE SHIFT=',EXTRA
	WRITE(1,*) 'EXTRAPOLATION OF PHASE SHIFT=',EXTRA
      ANDEL=-1.2583252220092437D0
	WRITE(*,*) '  EXACT VALUE OF PHASE SHIFT=',ANDEL
	WRITE(1,*) '  EXACT VALUE OF PHASE SHIFT=',ANDEL
	WRITE(*,*) 'ERROR=',EXTRA-ANDEL
	WRITE(1,*) 'ERROR=',EXTRA-ANDEL
	N=(IPOINT-1)*NN/2+1
	WRITE(1,*) 'WAVE FUNCTION'
	DO I=1,N
	WRITE(1,*) R(I),PSI(I)
	ENDDO
	END
C
      SUBROUTINE  INITIAL(PSI0,DLAM0,QQ,R,IPOINT,N)
      IMPLICIT REAL*8 (A-H,O-Z)
	PARAMETER (NP=2000,NPO=13)
      DIMENSION R(NP),PSI0(NP)
      DMP=8.876D0
	DP=0.104D0
	ALPHAP=0.67D0
	RAP=2.09D0
	DLAM0=-1.D0/(DCOS(QQ*R(1))*DTAN(-6.559D-4)+DSIN(QQ*R(1)))
      DO I=1,IPOINT-1
	PSI0(I)=HYPER1(QQ,R(I))
	ENDDO
	DO I=IPOINT,N
	IF (R(I).GE.0D0) THEN
	PSI0(I)=HYPER(QQ,R(I))
	ELSE
	PSI0(I)=HYPER1(QQ,R(I))
      ENDIF
	ENDDO
      RETURN
	END
C
	FUNCTION POT(R)
	IMPLICIT REAL*8 (A-H,O-Z)
      DMP=8.876D0
	DP=0.104D0
	ALPHAP=0.67D0
	RAP=2.09D0
	POT=2*DMP*DP*(DEXP(-2*ALPHAP*(R-RAP))-2*DEXP(-ALPHAP*(R-RAP)))
	RETURN
	END

C
      FUNCTION HYPER1(QQ,RR)
      IMPLICIT REAL*8 (A-H,O-Z)
	REAL OMEGA
      COMPLEX  I,Z1,Z2,CGAMMA
	I=(0.,1.)
      DM=8.876D0
	D=0.104D0
	ALPHA=0.67D0
	XALP=2.09D0
	DD=DSQRT(2.D0*DM*D)/ALPHA
	S=QQ/ALPHA
	R=RR
      XI=2*DD*DEXP(-ALPHA*(R-XALP))
	Z1=1+2*I*S
	Z2=-DD-I*S+0.5D0
	OMEGA=ATAN(AIMAG(CGAMMA(Z1))/REAL(CGAMMA(Z1)))
     -     +ATAN(AIMAG(CGAMMA(Z2))/REAL(CGAMMA(Z2)))
      Z1=1.D0-2*I*S
	Z2=0.5D0+DD-I*S
	HYPER1=DIMAG(CEXP(I*OMEGA)*CGAMMA(Z1)/CGAMMA(Z2)
     -	 *(-1.D0)**(DD+I*S-0.5D0))*XI**(DD-0.5D0)*DEXP(-0.5D0*XI)
 1001 FORMAT(1H1///5H Y = ,2E22.12)
      RETURN
	END 
C
      FUNCTION HYPER(QQ,RR)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16  DWHIT,I,DD,XI,S
	COMPLEX     Z1,Z2,CGAMMA 
	I=(0.D0,1.D0)
      DM=8.876D0
	D=0.104D0
	ALPHA=0.67D0
	XALP=2.09D0
	DD=DSQRT(2*DM*D)/ALPHA
	S=QQ/ALPHA
      XI=2.D0*DD*DEXP(-ALPHA*(RR-XALP))
	Z1=1.D0+2*I*S
	Z2=-DD-I*S+0.5D0
	OMEGA=ATAN(AIMAG(CGAMMA(Z1))/REAL(CGAMMA(Z1)))
     -     +ATAN(AIMAG(CGAMMA(Z2))/REAL(CGAMMA(Z2)))
	HYPER=DIMAG(DWHIT(DD,-I*S,XI)*XI**(-0.5D0)*CDEXP(I*OMEGA))
 1001 FORMAT(1H1///5H Y = ,2E22.12)
      RETURN
	END 
C
      COMPLEX*16 FUNCTION DWHIT(AK,AM,Z)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION F(600)
      COMPLEX*16 A,C,R,R1,R2,RH,Z,S1,S2,SS
      COMPLEX*16 F,AM,AK,ESPP
C
      DWHIT=0.0D0
      IF(CDABS(Z).NE.0.0D0) GO TO 4
      IF(DREAL(AM).GT.-0.5D0) RETURN
      WRITE(*, 300)
  300 FORMAT(5X,' SINGULARITY Z=0 AND REAL(AM).LE.-0.5')
      RETURN
    4 CONTINUE
      C=1.0D0+2.0D0*AM
      A=0.5D0*C-AK
      EPSI=6.0D0
      PREC=1.0D-6
      N=10
      IF(CDABS(Z).GT.7.0D0 ) N=1.7D0*CDABS(Z)
C
    2 CONTINUE
      E=2.0D0
      R1=1.0D0
      R2=(C-2.0D0*A)/C
      RH=2.0D0*C*R2
      M=2*N
      MAC=N
      CALL  BEWW(F,M,0.5D0*Z,EPSI)
      S1=F(1)-2.0D0*R2*F(2)
      ERROR =10.0D30
C
      DO 1 J=3,N
      EJ=J
      R=(RH*R2+(EJ-C-2.0D0)*R1)/(EJ+C-2.0D0)
      R1=R2
      R2=R
      S2=E*R*F(J)+S1
      E=-E
      H=CDABS(S1)
      IF(H.EQ.0.0D0) GO TO 1
      ERROR2=CDABS(S2-S1)/H
      IF (ERROR2.EQ.0.0D0) GO TO 1
      IF(ERROR.LE.ERROR2) GO TO 1
      MAC=J
      SS=S2
      ERROR=ERROR2
    1 S1=S2
      IF(ERROR .LE.PREC) GO TO 3
      N=N+5
      GO TO 2
C
    3 ESPP=(0.5D0+AM)*CDLOG(Z)
      DWHIT=SS*CDEXP(ESPP)
C
      RETURN
      END
      SUBROUTINE BEWW(F,M,Z,EPSI)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION F(M),B(4)
      COMPLEX*16 F,Z,AL,R1,R2,S,S1,S2,DUM1,DUM2
      COMPLEX*16 ZZ,B
C
      B(2)=1.0D0
      B(3)=-(0.0D0,1.0D0)
      B(4)=-1.0D0
      B(1)=(0.0D0,1.0D0)
      Z=(0.0D0,1.0D0)*Z
      ZZ=Z
      IF(DIMAG(Z).LT.0.0D0) Z=CONJG(Z)
      N=M/2
      IF(CDABS(Z).NE.0.0D0) GO TO 5
      F(1)=1.0D0
      DO 4 I=2,N
    4 F(I)=0.0D0
      RETURN
    5 CONTINUE
      NM=N-1
      CALL BOUND1(NU,NM,Z,EPSI)
      DO 12  K=N,M
   12 F(K)=0.0D0
C
    8 CONTINUE
      R1=0.0D0
      S1=0.0D0
      DO 1 K=N,NU
      KK=NU+N-K
      AK=KK
      R2=   -1.0D0/(-2.0D0*AK/Z+R1)
      R1=R2
      IF(DIMAG(Z).NE.0.0D0) GO TO 6
      AL=2*(1-MOD(KK,2))
    6 CONTINUE
      IF(DIMAG(Z).NE.0.0D0) AL=2.0D0*(0.0D0,-1.0D0)**KK
      S2=R2*(AL+S1)
    1 S1=S2
C
      F(N)=R2
      S1=S2
      DO 2 K=1,NM
      KK=N-K
      AK=KK
      F(KK)=-1.0D0/(-2.0D0*AK/Z+F(KK+1))
      IF(DIMAG(Z).NE.0.0D0) GO TO 7
      AL=2*(1-MOD(KK,2))
    7 CONTINUE
      IF(DIMAG(Z).NE.0.0D0) AL=2.0D0*(0.0D0,-1.0D0)**KK
      S2=F(KK)*(AL+S1)
    2 S1=S2
C
      S=1.0D0
      IF(DIMAG(Z).NE.0.0D0) S=CDEXP(-(0.0D0,1.0D0)*Z)
      DUM1=F(1)
      F(1)=S/(1.0D0+S2)
      DO 3 K=1,NM
      DUM2=F(K+1)
      F(K+1)=DUM1*F(K)
    3 DUM1=DUM2
      DO 9 K=1,N
      IF(CDABS((F(K)-F(N+K))/F(K)).GT.0.5D0*10.0D0**(-EPSI)) GO TO 10
    9 CONTINUE
      IF(DIMAG(ZZ).GE.0.0D0) GO TO 16
      DO 15 K=1,N
   15 F(K)=CONJG(F(K))
   16 DO 14 K=1,N
      JJ=1+MOD(K,4)
   14 F(K)=B(JJ)*F(K)
      Z=ZZ*(0.0D0,-1.0D0)
      RETURN
   10 NU=NU+5
      DO 11 K=1,N
   11 F(N+K)=F(K)
      GO TO 8
      END
      SUBROUTINE BOUND1(NU,NM,Z,EPSI)
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 Z
C
      Y1 = -1.0D38
      AN=NM
      E=2.718281828459045D0
      D=EPSI*DLOG(10.0D0)+DLOG(4.0D0)
      G=E*CDABS(Z)*0.5D0
      IF(DIMAG(Z).GE.D+CDABS(Z)*0.5D0) GO TO 1
      X1=   (D-DIMAG(Z))/G
      Y1 = G*TWHIT(X1)
    1 CONTINUE
      IF(AN.LE.G) AN=G+5.0D0
      X2=0.5D0*D/AN
      Y2 = AN * TWHIT(X2)
      NU=DMAX1(Y1,Y2)
      RETURN
      END
      DOUBLE PRECISION FUNCTION TWHIT(X)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION B(5)
      G=-1.0D0/2.718281828459045D0
      IF(X.GE.G.AND.X.LE.0.0D0) GO TO 1
      IF(X.GE.0.AND.X.LE.10.0D0) GO TO 2
      H=DLOG(X)
      T=X/(H*(1.0D0-DLOG(H)/(1.0D0+H)))
      TWHIT = T
      RETURN
    1 T=0.36788D0+1.0422D0*DSQRT(X+0.36788D0)
      TWHIT = T
      RETURN
    2 B(1)=-0.00176148D0
      B(2)=0.0208645D0
      B(3)=-0.129013D0
      B(4)=0.8577D0
      B(5)=1.0125D0
      T=0.000057941D0
      DO 4 I=1,5
    4 T=X*T+B(I)
      TWHIT = T
      RETURN
      END
C
      COMPLEX FUNCTION CGAMMA(Z)
      COMPLEX ZFACT
      COMPLEX Z
      COMPLEX U,V,H,S
      DIMENSION G(16)
      DATA PI /3.14159 26535 89793/
      DATA G
     1/41.62443 69164 39068,-51.22424 10223 74774,+11.33875 58134 88977,
     2 -0.74773 26877 72388, +0.00878 28774 93061, -0.00000 18990 30264,
     3 +0.00000 00019 46335, -0.00000 00001 99345, +0.00000 00000 08433,
     4 +0.00000 00000 01486, -0.00000 00000 00806, +0.00000 00000 00293,
     5 -0.00000 00000 00102, +0.00000 00000 00037, -0.00000 00000 00014,
     6 +0.00000 00000 00006/
      U=Z
   10 X=REAL(U)
      IF(X .GE. 1.0) GO TO 3
      IF(X .GE. 0.0) GO TO 2
      V=1.0-U
      L=1
      GO TO 11
    2 V=U+1.0
      L=2
      GO TO 11
    3 V=U
      L=3
   11 H=1.0
      S=G(1)
      DO 1 K = 2,16
      FK=K-2
      FK1=FK+1.0
      H=((V-FK1)/(V+FK))*H
    1 S=S+G(K)*H
      H=V+4.5
      CGAMMA=2.506628274631001*CEXP((V-0.5)*CLOG(H)-H)*S
      GO TO (21,22,23), L
   21 CGAMMA=PI/(CSIN(PI*U)*CGAMMA)
      RETURN
   22 CGAMMA=CGAMMA/U
   23 RETURN
      ENTRY ZFACT(Z)
      U=Z+1.0
      GO TO 10
      END

